/***************************************************************************
                          k8000.c  -  description
                             -------------------
    begin                : Mon May 29 2000
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *   This code is ported to Linux starting with the DOS routines delivered *
 *   by Velleman.                                                          *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id: k8000.h,v 1.2 2000/07/23 10:51:18 js Exp $
 *
 */

#define MaxIOcard 3
#define MaxIOchip 7
#define MaxIOchannel 64
#define MaxDACchannel 32
#define MaxADchannel 16
#define MaxDAchannel 4

extern short IOconfig[];
extern short IOdata[];
extern short IO[];
extern short DAC[];
extern short AD[];
extern short DA[];
extern short ControlPort;
extern short StatusPort;
extern short I2CbusDelay;

/*DOS CONVERSION PROCEDURES*/
void outport(int port, int value);
short inport(int port);

/*RADIX CONVERSION FUNCTIONS*/
void DecToBin(int DecNumber, char *BinNumber);
int BinToDec(char *BinNumber);
void DecToHex(int DecNumber, char *HexNumber);
int HexToDec(char *HexNumber);

/*IO CONFIGURATION PROCEDURES*/
void ConfigAllIOasInput(void);
void ConfigAllIOasOutput(void);
void ConfigIOchipAsInput(int Chip_no);
void ConfigIOchipAsOutput(int Chip_no);
void ConfigIOchannelAsInput(int Channel_no);
void ConfigIOchannelAsOutput(int Channel_no);

/*UPDATE IOdata & IO ARRAY PROCEDURES*/
void UpdateIOdataArray(int Chip_no, int Data);
void ClearIOdataArray(int Chip_no);
void SetIOdataArray(int Chip_no);
void SetIOchArray(int Channel_no);
void ClearIOchArray(int Channel_no);

/*OUTPUT PROCEDURES*/
void IOoutput(int Chip_no, int Data);
void UpdateAllIO(void);
void ClearAllIO(void);
void SetAllIO(void);
void UpdateIOchip(int Chip_no);
void ClearIOchip(int Chip_no);
void SetIOchip(int Chip_no);
void SetIOchannel(int Channel_no);
void ClearIOchannel(int Channel_no);

/*INPUT PROCEDURES*/
void ReadIOchip(int Chip_no);
void ReadAllIO(void);
void ReadIOchannel(int Channel_no);

/*6 BIT DAC CONVERTER PROCEDURES*/
void OutputDACchannel(int Channel_no, int Data);
void UpdateDACchannel(int Channel_no);
void ClearDACchannel(int Channel_no);
void SetDACchannel(int Channel_no);
void UpdateDACchip(int Chip_no);
void ClearDACchip(int Chip_no);
void SetDACchip(int Chip_no);
void UpdateAllDAC(void);
void ClearAllDAC(void);
void SetAllDAC(void);

/*8 BIT DA CONVERTER PROCEDURES*/
void OutputDAchannel(int Channel_no, int Data);
void UpdateDAchannel(int Channel_no);
void ClearDAchannel(int Channel_no);
void SetDAchannel(int Channel_no);
void UpdateAllDA(void);
void ClearAllDA(void);
void SetAllDA(void);

/*8 BIT AD CONVERTER PROCEDURES*/
void ReadADchannel(int Channel_no);
void ReadADchip(int Chip_no);
void ReadAllAD(void);

/*GENERAL PROCEDURES*/
void ReadAll(void);
void ReadCard(int Card_no);
void UpdateAll(void);
void UpdateCard(int Card_no);

/*I2C BUS CONDITIONS*/
void SelectI2CprinterPort(int Printer_no);
void I2CBusNotBusy(void);
